<?php

/*
* @title		myFlickr - Joomla content Plugin
* @version		1.08
* @copyright	Copyright (C) 2011 Piotr Wołoszyn. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL, see LICENSE.php
*
* http://www.in-web.pl
* ptrwoloszyn@gmail.com
*
*/


defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.event.plugin' );
jimport( 'joomla.html.parameter' );

class plgContentMyFlickr extends JPlugin

{
	
	private $cache;
	
	protected $show_benchmark = false;
	private $cache_enabled = true;
	private $cache_expired = 3600;		
	
	protected $api_key;
	private $feed;
	private $displaymode;
	private $gallerytype;
	private $thumbsize;
	private $imagesize;
	private $flickrsp;
	private $perpage;
	private $page;
	private $columns;
	private $resize;
	private $random;
	private $user_id;
	private $group_id;	
	private $photoset_id;
	private $showtitle;
	private $flickrlink;
	private $powered_by;
	private $imagestyle;
	private $custom_css;
	private $album_no = 0;
	private $captions;
	private $thumbtitle_position;
	private $thumbcaption_type;
	private $flickrtext;
	
	
	private $tags;
	private $tag_mode;
	private $text;
	private $sort;	
	private $min_upload_date;
	private $max_upload_date;
	private $min_taken_date;
	private $max_taken_date;
	
	private $fancybox_border;
	private $fancybox_cyclic;
	private $colorbox_style;	
	
	
	private $load_jquery;
	private $jquery = false;
	private $generic_javascript;
	private $generic_handler;	
	private $onready_js = "";
	private $vartab = array();
	private $find_size = false;

	private	$size_array	= array ( 
						0 => 'sq',
						1 => 't',
						2 => 's',
						3 => 'm',
						4 => 'z',
						5 => 'l',
						6 => 'o'
						);
	
	private	$rang_array = array (
						'sq' => 0,
						't' => 1,
						's' => 2,
						'm' => 3,
						'z' => 4,
						'l' => 5,
						'o' => 6
						);	
	
	private $found_myflickr = false;
	
	function plgContentMyFlickr( &$subject, $params )
	{
			
		parent::__construct( $subject, $params );

	}



	function onContentPrepare( $context, &$article, &$params, $limitstart )
	{
	
		if($this->show_benchmark){
			$time = microtime();
			$time = explode(' ', $time);
			$time = $time[1] + $time[0];
			$begintime = $time;
		}
	
		$mainframe = &JFactory::getApplication();
		$document = JFactory::getDocument();

		$regex = '#{myFlickr}(.*?){/myFlickr}#s';
		$article->text = preg_replace_callback($regex,array($this,"render"), $article->text);
		/*
		$regex = '#{myFlickr photo}(.*?){/myFlickr}#s';
		$article->text = preg_replace_callback($regex,array($this,"renderphoto"), $article->text);
		*/
		if($this->found_myflickr){
		
			$document->addStyleSheet($this->get_plugin_web_path('myFlickr.css'));		
			$this->onready_script();
		
		}
		
		if($this->show_benchmark){		
			$time = microtime();
			$time = explode(" ", $time);
			$time = $time[1] + $time[0];
			$endtime = $time;
			$totaltime = ($endtime - $begintime);
			echo 'PHP parsed this page in ' .$totaltime. ' seconds.';
		}
		
		return true;

	}

	function renderphoto($string){
		
		$args = explode(',',$string[1]);
		
		$url = trim($args[0]);
		
		$this->imagestyle = isset($args[1]) ? strtolower(trim($args[1])) : 'nostyle';
		
		$height = isset($args[2]) ? (int) trim($args[2]) : 200;
		
		$width = isset($args[3]) ? (int) trim($args[3]) : 200;
		
		$html_output = "<img src='".$url."'>";
		
		$html_output = $this->imagestyle($html_output,$height,$width);
		
		return $html_output;
			
	}

	function render($params)
	{
		
		$this->found_myflickr = true;
		
		$this->init();
						
		$this->parseParams($params[1]);
		
		if($this->imagestyle == 'custom')
		{
			
			if ($this -> custom_css ){
				
				$document = JFactory::getDocument();
				
				$style = "div.myF-css-custom{".$this->custom_css."}".PHP_EOL;			
				$style .= "div.myF-css-custom:hover{".$this->custom_css_hover."}".PHP_EOL;			
			
				$document->addStyleDeclaration($style);
			
			}
			
		}	
		
		$myFlickr = new myFlickr($this->api_key);
		
		$html_output = "";
		
		if($this->find_size){
		
			$extras = "url_sq,url_t,url_s,url_m,url_z,url_l,url_o,owner_name";
					
		} else {
		
			$extras = "url_".$this->thumbsize.",url_".$this->imagesize.",owner_name";
		
		}		
		
		if($this->captions){
		
			$extras .= ",description,date_taken,tags";
		
		}
		
		
		$args = array (
		
			'photoset_id'		=> $this->photoset_id,
			
			'user_id'			=> $this->user_id,
			
			'group_id'			=> $this->group_id,
			
			'tags'				=> $this->tags, 
	
			'tag_mode'			=> $this->tag_mode,
			
			'text'				=> $this->text,

			'sort'				=> $this->sort,
			
			'min_upload_date'	=> $this->min_upload_date,
	
			'max_upload_date'	=> $this->max_upload_date,
			
			'min_taken_date'	=> $this->min_taken_date,
	
			'max_taken_date'	=> $this->max_taken_date,			

			'per_page'			=> $this->perpage,

			'page' 				=> $this->page,

			'extras'			=> $extras
		
		);
		
		if( $this->cache_enabled ){
			
			require_once('myFlickr/JG_Cache.class.php');
			
			$cache = new JG_Cache($this->get_plugin_web_path('cache')); 
			
			$hash = sha1( serialize($args) );
			$key = $this->feed . '_' . $hash;

			if( !($this->flickrrsp = $cache -> get( $key, $this->cache_expired ) ) ){
			
				switch($this -> feed){
				
					case 'search'		: $this -> flickrrsp = $myFlickr -> photosSearch($args); break;			
					case 'group'		: $this -> flickrrsp = $myFlickr -> groupsPoolsGetPhotos($args); break;		
					case 'user'			: $this -> flickrrsp = $myFlickr -> peopleGetPublicPhotos($args); break;			
					case 'photoset'		: $this -> flickrrsp = $myFlickr -> photosetsGetPhotos($args); break;			
					case 'recent' 		: $this -> flickrrsp = $myFlickr -> photosGetRecent($args); break;			
					default 			: $this -> flickrrsp = $myFlickr -> photosGetRecent($args); break;
				
				}
				
				$cache -> set($key,$this->flickrrsp);
			
			}
				
		} else {
		
			switch($this -> feed){
			
				case 'search'		: $this -> flickrrsp = $myFlickr -> photosSearch($args); break;			
				case 'group'		: $this -> flickrrsp = $myFlickr -> groupsPoolsGetPhotos($args); break;		
				case 'user'			: $this -> flickrrsp = $myFlickr -> peopleGetPublicPhotos($args); break;			
				case 'photoset'		: $this -> flickrrsp = $myFlickr -> photosetsGetPhotos($args); break;			
				case 'recent' 		: $this -> flickrrsp = $myFlickr -> photosGetRecent($args); break;			
				default 			: $this -> flickrrsp = $myFlickr -> photosGetRecent($args); break;
			
			}			
		
		}
		
		if($this -> flickrrsp){
		
			switch($this -> displaymode){
				
				case 'gallery' 		: $output = $this -> display_gallery(); break;
				
				case 'list' 		: $output = $this -> display_list(); break;
				
				default 			: $output = $this -> display_gallery();

			}
			
			if($output){
			
				$html_output = $this->wrap($output);
			
			} else {
			
				$html_output = "Error while rendering plugin content.";
			
			}
			
		
		} else {
		
			$html_output = $myFlickr -> getLastError();
		
		}
		
		return $html_output;
	
	}
	
	function wrap($content){
	
		$wrapped_content = "<div class=\"myFlickr-gallery\">";
		
		$wrapped_content .= $content;
		
		if (!$this->powered_by) {$wrapped_content .= "<p style=\"font-size: 8px; color:#a6b2be; text-align: center\"><a style=\"font-size: 8px;\" title=\"Learn more about myFlickr - Joomla Content Plugin here\" href=\"http://www.in-web.pl\"><span style=\"color: #a6b2be\">Powered by </span><span style=\"color: #0063dc\">m</span><span style=\"color: #ff0084\">y</span><span style=\"color: #a6b2be\">Flickr</span></a></p>";}
		
		$wrapped_content .= "</div>";
		
		return $wrapped_content;
	
	}
	
	function init()
	{
			
		require_once('myFlickr/myFlickr.class.php');
		
		$this->album_no++;
		
		$plugin = JPluginHelper::getPlugin('content', 'myFlickr');

		$pluginParams = new JParameter( $plugin->params );
		
		$this->api_key 					= $pluginParams->get('api_key', "");
		
		$this->feed						= $pluginParams->get('feed', 1);
		
		$this->displaymode				= $pluginParams->get('displaymode', "list");
		
		$this->gallerytype				= $pluginParams->get('gallerytype', "generic");

		$this->thumbsize				= $pluginParams->get('thumbsize', "sq");

		$this->imagesize				= $pluginParams->get('imagesize', "m");
		
		$this->perpage					= $pluginParams->get('perpage', 10);
		
		$this->columns					= $pluginParams->get('columns', 0);
		
		$this->showtitle				= $pluginParams->get('showtitle', 1);
		
		$this->flickrlink				= $pluginParams->get('flickrlink', 0);
		
		$this->powered_by				= $pluginParams->get('powered_by', false);
		
		$this->imagestyle				= $pluginParams->get('imagestyle', "");
		
		$this->custom_css		  		= $pluginParams->get('custom_css', false);
		
		$this->custom_css_hover	  		= $pluginParams->get('custom_css_hover', false);
		
		$this->resize					= false;
			
		$this->random					= false;	
			
		$this->page						= '1';
		
		$this->photoset_id				= '';
		
		$this->captions					= $pluginParams->get('captions', false);
		
		$this->thumbtitle_position		= $pluginParams->get('thumbtitle_position', 'above');
		
		$this->thumbcaption_type		= $pluginParams->get('thumbcaption_type', false);

		$this->flickrtext				= $pluginParams->get('flickrtext', false);			
		
		$this->user_id					= $pluginParams->get('user_id', "");
		
		$this->find_size  				= $pluginParams->get('find_size', false);
		
		$this->load_jquery 	 			= $pluginParams->get('load_jquery', true);
		
		$this->fancybox_border			= is_numeric($pluginParams->get('fancybox_border', 1)) ? $pluginParams->get('fancybox_border', 1) : 10;
		
		$this->fancybox_cyclic 			= $pluginParams->get('fancybox_cyclic', 1);
		
		$this->generic_handler  		= $pluginParams->get('generic_handler', false);
		
		$this->generic_javascript  		= $pluginParams->get('generic_javascript', false);
		
		$this->colorbox_style			= is_numeric($pluginParams->get('colorbox_style', 1)) ? $pluginParams->get('colorbox_style', 1) : 1;
		
		$this->cache_enabled			= $pluginParams->get('cache_enabled', true);

		$this->cache_expired			= is_numeric($pluginParams->get('cache_expired', 3600)) ? $pluginParams->get('cache_expired', 3600) : 3600;
		
	}
	
	
	function parseParams($params)
	{

		foreach (explode(',', $params) as $nextParameter) {


			if (($paramPos = strpos($nextParameter, '=')) === false) {

				$nextKey = strtolower(trim($nextParameter));

				$nextVal = '';

			} else {

				$nextKey = strtolower(trim(substr($nextParameter, 0, $paramPos)));

				$nextVal = trim(substr($nextParameter, $paramPos+1, strlen($nextParameter)));

			}



			switch ($nextKey) {

				case 'displaymode'				: $this->displaymode = strtolower($nextVal); break;
				
				case 'gallerytype'				: $this->gallerytype = strtolower($nextVal); break;
				
				case 'feed'						: $this->feed = strtolower($nextVal); break;
				
				case 'thumbsize' 				: $this->thumbsize = strtolower($nextVal); break;

				case 'imagesize' 				: $this->imagesize = strtolower($nextVal); break;
			
				case 'perpage'	 				: $this->perpage = is_numeric($nextVal) ? $nextVal : 10; break;
				
				case 'page'	 					: $this->page = is_numeric($nextVal) ? $nextVal : 1; break;
				
				case 'columns'	 				: $this->columns = is_numeric($nextVal) ? $nextVal : 0; break;
				
				case 'resize'	 				: $this->resize = is_numeric($nextVal) ? $nextVal : false; break;
				
				case 'random'	 				: $this->random = is_numeric($nextVal) ? $nextVal : 1; break;
				
				case 'imagestyle' 				: $this->imagestyle = strtolower($nextVal); break;

				case 'showtitle' 				: $this->showtitle = true; break;
				
				case 'flickrlink' 				: $this->flickrlink = $nextVal; break;
				
				case 'user_id'	 				: $this->user_id = $nextVal; break;
				
				case 'photoset_id' 				: $this->photoset_id = $nextVal; break;
				
				case 'group_id' 				: $this->group_id = $nextVal; break;
				
				case 'captions'					: $this->captions = $nextVal; break;
				
				case 'tags'						: $this->tags = $nextVal; break; 
	
				case 'tag_mode'					: $this->tag_mode = $nextVal; break;
			
				case 'text'						: $this->text = $nextVal; break;
				
				case 'sort'						: $this->sort = $nextVal; break;
			
				case 'min_upload_date'			: $this->min_upload_date = $nextVal; break;
	
				case 'max_upload_date'			: $this->max_upload_date = $nextVal; break;
			
				case 'min_taken_date'			: $this->min_taken_date = $nextVal; break;
	
				case 'max_taken_date'			: $this->max_taken_date = $nextVal; break;				
				
				case 'fancybox_border' 			: $this->fancybox_border = is_numeric($nextVal) ? $nextVal : 10; break;
				
				case 'fancybox_cyclic'			: $this->fancybox_cyclic = $nextVal; break;
				
				case 'cache'					: if($nextVal == 'true' || $nextVal=='1' || $nextVal=='yes' ) {$this->cache_enabled = true;} else {$this->cache_enabled = false;} break;

			}

		}

	}
	
	function display_list(){
	
		$output = "";

		if($this->flickrrsp){
			
			$photos = $this->return_photos();
			
			if($this->columns > 0)
			{			
				
				
				
				$counter = 0;
				
				$output .= "<table><tbody>";	
			
				foreach($photos['photo'] as $photokey => $photo)
				{	
						
						if($this->feed == 'photoset')
						{
						
							$photo['owner'] = $photos['owner'];
						
						}

						if( $counter == 0 ) { $output .= "<tr>";}
						
						$output .= "<td>".$this -> prepare_photo($photo)."</td>";						
						
						$counter++;
						
						if( $counter == $this->columns ) { $output .= "</tr>"; $counter = 0; }
						
				}
				
				$output .= "</tbody></table>";	
				
			}
			
			else{
			
			
				foreach($photos['photo'] as $photokey => $photo)
				{	
						
					if($this->feed == 'photoset')
					{
					
						$photo['owner'] = $photos['owner'];
					
					}

					$output .= $this -> prepare_photo($photo);					
				
				}
				
			
			}
			
		}
		else{
		
			return false;
		
		}
		
		return $output;		
	
	}
	
	function onready_script()
	{
		
		$document = JFactory::getDocument();
		
		$script = "";
		
		$generic_js = trim($this->generic_javascript);
		
		if(!empty($generic_js)){
		
			$script .= "\n".$generic_js."\n";
		
		}
		
		if($this->jquery)
		{
			
			$script .= "jQuery(document).ready(function($){\n";			
			$script .= $this->onready_js;			
			$script .="});\n";
		
		} else {
		
			$script .= $this->onready_js;
		
		}
		
		if( !empty($script) ){
			$document->addScriptDeclaration($script);
		}
	}	
	
	function display_gallery()
	{
		
		$output = "";
		
		switch($this->gallerytype){
			
			case 'generic'	 	: $output = $this->display_gallery_generic(); break;
			
			case 'colorbox'	 	: $output = $this->display_gallery_colorbox(); break;
			
			case 'fancybox' 	: $output = $this->display_gallery_fancybox(); break;
			
			default				: $output = $this->display_gallery_generic();
		
		}
		
		return $output;
		
	}
	
	
	function display_gallery_generic()
	{

		$output = "";
		
		$onclick = "";
		
		$style = "style=\"cursor: pointer;\"";
		
		if($this->generic_handler){
		
			$onclick = "onclick=\"".$this->generic_handler."(this);\"";
			
		}
		
		
		if($this->flickrrsp){
			
			$photos = $this->return_photos();
			
			if($this->columns > 0)
			{
				
				$counter = 0;
				
				$output .= "<table><tbody>";			
			
					foreach($photos['photo'] as $photokey => $photo)
					{			
						
						if($this->feed == 'photoset')
						{
						
							$photo['owner'] = $photos['owner'];
						
						}

						if( $counter == 0 ) { $output .= "<tr>";}
						
						$output .= "<td>".$this -> prepare_photo($photo)."</td>";
						
						$counter++;
						
						if( $counter == $this->columns ) { $output .= "</tr>"; $counter = 0; }
						
					}
				
				$output .= "</tbody></table>";
				
			} else {
			
				foreach($photos['photo'] as $photokey => $photo)
				{			

					$url = "";
					
					if($this->feed == 'photoset')
					{
					
						$photo['owner'] = $photos['owner'];
					
					}

					$output .= $this -> prepare_photo($photo);
					
				}			
			
			}
		}
		else{
		
			return false;
		
		}
		
		return $output;		
	
	}	

	function return_photos(){
	
		switch($this->feed){
			
			case 'search' 	: $photos = $this->flickrrsp['photos']; break;
			
			case 'user' 	: $photos = $this->flickrrsp['photos']; break;
			
			case 'group' 	: $photos = $this->flickrrsp['photos']; break;
			
			case 'photoset' : $photos = $this->flickrrsp['photoset']; break;
				
			case 'recent' 	: $photos = $this->flickrrsp['photos']; break;
				
			default			: $photos = $this->flickrrsp['photos'];
			
		}
		
		if($this->random)
		{
		
				$random = array_rand($photos['photo'],$this->random);
				
				if(!is_array($random))
				{
					
					$arr = array( 0 => $random );
					$random = $arr;
					
				}
				
				$new_photo_arr = array();
				
				$i = 0;
				
				foreach($random as $key)
				{
				
					$new_photo_arr[$i] = $photos['photo'][$key];
					$i++;
					
				}
				
				$photos['photo'] = $new_photo_arr;
		
		}
		
		return $photos;
	
	}
	
	function wrapWithCaptions($content,$photo,$size)
	{
		
		$flickr_url = "http://www.flickr.com/photos/". $photo['owner'] . "/" . $photo['id'];
		
		$description = !empty($photo['description']['_content']) ? $photo['description']['_content'] : "";
		
		$title = !empty($photo['title']) ? $photo['title'] : false;
		
		if($this->thumbcaption_type)
		{
		
			switch($this->thumbcaption_type)
			{
			
				case 'none'	 : 	$description = ""; 
								break;
				case 'desc1' : 	$description = 	"<span class=\"myF-desc\">".$description."</span>"; 
								break;
				case 'desc2' :	$description = 	"<span class=\"myF-desc\">".$description."</span></br>";
								if($this->flickrtext) $description .= "<span class=\"myF-descflickr\"><a href=\"".$flickr_url."\" target=\"_blank\">".$this->flickrtext."</a></span>";
								else $description .= "<span class=\"myF-descflickr\"><a href=\"".$flickr_url."\" target=\"_blank\">".$flickr_url."</a></span>";
								break;
				case 'desc3' : 	$description = 	"<span class=\"myF-desc\">".$description."</span></br>";
								$description .=	"<span class=\"myF-descowner\"><span class=\"label\">Author: </span>".$photo['ownername']."</span></br>";
								$description .=	"<span class=\"myF-descdate\"><span class=\"label\">Date: </span>".$photo['datetaken']."</span></br>";
								if($photo['tags']) $description .=	"<span class=\"myF-descdate\"><span class=\"label\">Tags: </span>".$photo['tags']."</span></br>";
								if($this->flickrtext) $description .= "<span class=\"myF-descflickr\"><a href=\"".$flickr_url."\" target=\"_blank\">".$this->flickrtext."</a></span>";
								else $description .= "<span class=\"myF-descflickr\"><a href=\"".$flickr_url."\" target=\"_blank\">".$flickr_url."</a></span>";
								break;
				case 'desc4' : 	if($this->flickrtext) $description = "<span class=\"myF-descflickr\"><a href=\"".$flickr_url."\" target=\"_blank\">".$this->flickrtext."</a></span>";
								else $description = "<span class=\"myF-descflickr\"><a href=\"".$flickr_url."\" target=\"_blank\">".$flickr_url."</a></span>";
								break;			
				case 'desc5' : 	$description =	"<span class=\"myF-descowner\"><span class=\"label\">Author: </span>".$photo['ownername']."</span></br>";
								$description .=	"<span class=\"myF-descdate\"><span class=\"label\">Date: </span>".$photo['datetaken']."</span></br>";
								if($photo['tags']) $description .=	"<span class=\"myF-descdate\"><span class=\"label\">Tags: </span>".$photo['tags']."</span></br>";
								break;
		
			}
		
		}
		

		
		$output = "<div class=\"myF-descwrapper\" style=\"display: inline-block; width: ".($size['width'] + 20)."px\">";
			
		if($this->thumbtitle_position == 'above' && $title) $output .= "<p class=\"myF-title\">".$title."</p>";
		
		$output .= $content;
		
		if($this->thumbtitle_position == 'below' && $title) $output .= "<p class=\"myF-title\">".$title."</p>";
		
		if($description) $output .= "<p class=\"myF-description\">".$description."</p>";
		
		$output .= "</div>";
		
		return $output;
		
	}
	
	function display_gallery_fancybox()
	{
		
		$document = JFactory::getDocument();
		
		$document->addStyleSheet($this->get_plugin_web_path('fancybox/jquery.fancybox-1.3.4.css'));
		
		if($this->load_jquery) {
		
			$document->addScript($this->get_plugin_web_path('jquery.min.js'));
			$document->addScriptDeclaration("jQuery.noConflict();\n");
			
		}	

		
		$document->addScript($this->get_plugin_web_path('fancybox/jquery.mousewheel-3.0.4.pack.js'));
		
		$document->addScript($this->get_plugin_web_path('fancybox/jquery.fancybox-1.3.4.pack.js'));			
		
		$this->jquery = true;
		
		$fancybox_advanced ="";
		
		if($this->flickrlink){
		
			$fancybox_advanced .= ", titleFormat: function(title, currentArray, currentIndex, currentOpts){
					
					if (title && title.length) {
						
						var id = $(\"a[title='\"+ title+ \"']\").attr('id');
						var id_split = id.split('-');
						var owner = id_split[1];
						var photoid = id_split[0];
						
						title = '<a href=\"http://www.flickr.com/photos/' + owner + '/' + photoid + '\" target=\"_blank\">' + $(this).attr('title') + '</a>';
					
						if (currentOpts.titlePosition == 'float') {
							return '<table id=\"fancybox-title-float-wrap\" cellpadding=\"0\" cellspacing=\"0\"><tr><td id=\"fancybox-title-float-left\"></td><td id=\"fancybox-title-float-main\">' + title + '</td><td id=\"fancybox-title-float-right\"></td></tr></table>';
						}

						return '<div id=\"fancybox-title-' + currentOpts.titlePosition + '\">' + title + '</div>';
					}
					
			}";	
			
		}
			
		
		$this->onready_js .= "$(\"a[rel*=myFgroup-".$this->album_no."]\").fancybox({ 'hideOnContentClick': true, 'padding': '".$this->fancybox_border."px', 'titleShow': ".$this->bool_to_string($this->showtitle).", 'cyclic': ".$this->bool_to_string($this->fancybox_cyclic).$fancybox_advanced."}); \n";
		
		$output = $this->thumbnails();
		
		return $output;
	
	}
	
	function display_gallery_colorbox()
	{
		
		$document = JFactory::getDocument();
		
		$document->addStyleSheet($this->get_plugin_web_path('colorbox/css/'.$this->colorbox_style.'/colorbox.css'));
		
		if($this->load_jquery) {
		
			$document->addScript($this->get_plugin_web_path('jquery.min.js'));
			$document->addScriptDeclaration("jQuery.noConflict();\n");
			
		}
		
		$document->addScript($this->get_plugin_web_path('colorbox/jquery.colorbox-min.js'));
		
		$this->jquery = true;
		
		$colorbox_advanced = "";
		
		if($this->flickrlink){
		
			$colorbox_advanced .= "title: function(){
				
				id = $(this).attr('id');
				id_split = id.split('-');
				owner = id_split[1];
				photoid = id_split[0];

				return '<a href=\"http://www.flickr.com/photos/' + owner + '/' + photoid + '\" target=\"_blank\">' + $(this).attr('title') + '</a>';
				
			}";
		
		}
		
		
		$this->onready_js .= "$(\"a[rel*=myFgroup-".$this->album_no."]\").colorbox({".$colorbox_advanced."}); \n";
		
		$output = $this->thumbnails();
		
		return $output;
	
	}	
	
	function thumbnails(){
	
		$output = "";

		if($this->flickrrsp){
			
			$photos = $this->return_photos();
			
			if($this->columns > 0)
			{
				
				$counter = 0;
				
				$output .= "<table><tbody>";
				
				foreach($photos['photo'] as $photokey => $photo)
				{			
					
					if($this->feed == 'photoset')
					{
					
						$photo['owner'] = $photos['owner'];
					
					}

					if( $counter == 0 ) { $output .= "<tr>"; }
					
					$output .= "<td>".$this -> prepare_photo($photo)."</td>";
					
					$counter++;
					
					if( $counter == $this->columns ) { $output .= "</tr>"; $counter = 0; }
					
				}
				
				$output .= "</tbody></table>";
			
			}
			else{
			
				foreach($photos['photo'] as $photokey => $photo)
				{			

					if($this->feed == 'photoset')
					{
					
						$photo['owner'] = $photos['owner'];
					
					}
					
					$output .= $this -> prepare_photo($photo);
				
				}		
			}			
		}
		else{
		
			return false;
		
		}
		
		return $output;
	}	
	
	function prepare_photo($photo)
	{

		$url = "";
		$onclick = "";		
		
		if($this->generic_handler && $this->gallerytype=='generic'){
		
			$onclick = "onclick=\"".$this->generic_handler."(this);\"";
			
		}
		
		if($this->find_size){
			
			if(isset($photo['url_'.$this->imagesize]) && !empty($photo['url_'.$this->imagesize])){		
			
				$direct_url = $photo['url_'.$this->imagesize];
			
			} else {
				
				$direct_url = $photo[$this->find_next_available_size($photo)];
				
			}		
		
		} else {
			
			$direct_url = $photo['url_'.$this->imagesize];	
			
		}

		
		$flickr_url = "http://www.flickr.com/photos/". $photo['owner'] . "/" . $photo['id'];
		
		if($this->gallerytype=='generic' && $this->flickrlink)
		{

			$url = $flickr_url;
			
		} else {
		
			$url = $direct_url;
			
		}
	
		$img_size = $this->prepare_size($photo['height_'.$this->thumbsize],$photo['width_'.$this->thumbsize]);
		
		$img = "<img src=\"".$photo['url_'.$this->thumbsize]."\" height=\"".$img_size['height']."\" width=\"".$img_size['width']."\" title=\"".$photo['title']."\" alt=\"".$url."\" ".$onclick." class=\"thumb\" />";
		$img = $this -> imagestyle($img, $img_size['height'], $img_size['width']);
		
		$img_output = "";
		
		if(!$onclick && !($this->displaymode == 'list')) $img_output .= "<a href='".$url."' title='".$photo['title']."' class='myFgroup-".$this->album_no."' rel='myFgroup-".$this->album_no."' id='".$photo['id']."-".$photo['owner']."'>";
		$img_output .= $img;
		if(!$onclick && !($this->displaymode == 'list')) $img_output .= "</a>";
		
		if($this->captions) $img_output = $this -> wrapWithCaptions($img_output, $photo, $img_size);

		return $img_output;
	
	}
	
	function find_next_available_size($photo){
	
		$rang = $this->rang_array[$this->imagesize];
		$next_size = $this->imagesize;
		
		while($rang >= 0 && $next_size == $this->imagesize)
		{
			$rang--;			
			if(isset($photo['url_'.$this->size_array[$rang]]) && !empty($photo['url_'.$this->size_array[$rang]])){
			
				$next_size = $this->size_array[$rang];
			
			}
			
		}
	
		return "url_".$next_size;
	
	}
	
	function prepare_size($o_height,$o_width){
		
		$output = "";
		
		if($this->resize){
		
			$o_height = (int) $o_height;
			$o_width = (int) $o_width;
			
			$new_size = (int) $this->resize;

			if($o_width > $o_height)
			{
				
				$new_width = $new_size;
				
				$new_height = $o_height * 1 / ($o_width / $new_size);
							
			} elseif($o_width < $o_height) {
			
				$new_height = $new_size;
				
				$new_width = $o_width * 1 / ($o_height / $new_size);
				
			} else {
			
				$new_height = $new_size;
				$new_width = $new_size;
			
			}
			
			$output = array( 'height' => $new_height,'width' => $new_width );
		
		}
		else{
		
			$output = array( 'height' => $o_height,'width' => $o_width );

		}
		
		return $output;
	
	}
	
	function imagestyle($img, $height, $width)
	{
		
		$output = "";
		
		switch($this->imagestyle)
		{
			case 'nostyle' 		: $output = $img; break;
			case 'strong' 		: $output = $this -> strong($img, $height, $width); break;
			case 'shadow' 		: $output = $this -> shadow($img, $height, $width); break;
			case 'grayglow'		: $output = $this -> grayglow($img, $height, $width); break;
			case 'css1'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css1'); break;
			case 'css2'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css2'); break;
			case 'css3'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css3'); break;
			case 'css4'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css4'); break;
			case 'css5'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css5'); break;
			case 'css6'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css6'); break;
			case 'css7'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css7'); break;
			case 'css8'			: $output = $this -> add_css_class($img, $height, $width, 'myF-css8'); break;				
			case 'custom'		: $output = $this -> add_css_class($img, $height, $width, 'myF-css-custom'); break;
			default 			: $output = $img;
		}
		
		return $output;
	
	}
	
	function grayglow($content, $height, $width)
	{
		
		$output = 	"<div class=\"myF-grayglow-wrapper\">
						<div class=\"myF-grayglow-nw\"></div>
						<div class=\"myF-grayglow-n\" ></div>
						<div class=\"myF-grayglow-ne\"></div>
						<div class=\"myF-grayglow-w\" ></div>
						<div class=\"myF-grayglow-content\" style=\"width:".$width."px; height:".$height."px\">".$content."</div>
						<div class=\"myF-grayglow-e\"></div>
						<div class=\"myF-grayglow-sw\"></div>
						<div class=\"myF-grayglow-s\"></div>
						<div class=\"myF-grayglow-se\"></div>
					</div>";
					
		return $output;			
		
	}
	
	function strong($content, $height, $width)
	{
		
		$output = 	"<div class=\"myF-strong-wrapper\">
						<div class=\"myF-strong-nw\"></div>
						<div class=\"myF-strong-n\" ></div>
						<div class=\"myF-strong-ne\"></div>
						<div class=\"myF-strong-w\" ></div>
						<div class=\"myF-strong-content\" style=\"width:".$width."px; height:".$height."px\">".$content."</div>
						<div class=\"myF-strong-e\"></div>
						<div class=\"myF-strong-sw\"></div>
						<div class=\"myF-strong-s\"></div>
						<div class=\"myF-strong-se\"></div>
					</div>";
					
		return $output;			
		
	}	
	
	function shadow($content, $height, $width)
	{
		
		$output = 	"<div class=\"myF-shadow-wrapper\">
						<div class=\"myF-shadow-nw\"></div>
						<div class=\"myF-shadow-n\" ></div>
						<div class=\"myF-shadow-ne\"></div>
						<div class=\"myF-shadow-w\" ></div>
						<div class=\"myF-shadow-content\" style=\"width:".$width."px; height:".$height."px\">".$content."</div>
						<div class=\"myF-shadow-e\" style=\"height:".($height-15)."px;\"></div>
						<div class=\"myF-shadow-e2\" ></div>
						<div class=\"myF-shadow-sw\"></div>
						<div class=\"myF-shadow-s\" style=\"width:".($width-15)."px;\"></div>
						<div class=\"myF-shadow-s2\" ></div>
						<div class=\"myF-shadow-se\"></div>
					</div>";
					
		return $output;			
		
	}
	
	function add_css_class($img, $height, $width, $class){
		
		return "<div class='".$class."' style=\"width:".$width."px; height:".$height."px\">".$img."</div>";
	
	}

	function get_web_path($relpath) 
	{
		return JURI::root(true) . ($relpath[0] != '/' ? '/' : '') . $relpath;
	}

	function get_plugin_web_path($relpath) 
	{
		
		return $this->get_web_path('/plugins/content/myFlickr/myFlickr' . ($relpath[0] != '/' ? '/' : '') . $relpath);
		
	}

	function bool_to_string($value){
	
		if($value == 1 || $value == true || $value == "true")
		{
		
			return "true";
					
		} else {
		
			return "false";
		
		}
	
	}
	
}